%define major		2.10
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

Name:		cpprest
Version:	2.10.18
Release:	%mkrel 1
Summary:	C++ REST library
License:	MIT
Group:		System/Libraries
URL:		https://github.com/Microsoft/cpprestsdk
Source0:	https://github.com/Microsoft/cpprestsdk/archive/v%{version}/cpprestsdk-%{version}.tar.xz
BuildRequires:	cmake
BuildRequires:	gcc-c++
BuildRequires:	boost-devel
BuildRequires:	websocketpp-devel
BuildRequires:	pkgconfig(libbrotlidec)
BuildRequires:	pkgconfig(libbrotlienc)
BuildRequires:	pkgconfig(openssl)

%description
The C++ REST SDK is a Microsoft project for cloud-based client-server
communication in native code using a modern asynchronous C++ API design. This
project aims to help C++ developers connect to and interact with services.

Also known as Casablanca.

#------------------------------------------------

%package -n	%{libname}
Summary:	C++ Rest library
Group:		System/Libraries

%description -n	%{libname}
The C++ REST SDK is a Microsoft project for cloud-based client-server
communication in native code using a modern asynchronous C++ API design. This
project aims to help C++ developers connect to and interact with services.

#------------------------------------------------

%package -n	%{develname}
Summary:	Development package for %{name}
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
The C++ REST SDK is a Microsoft project for cloud-based client-server
communication in native code using a modern asynchronous C++ API design. This
project aims to help C++ developers connect to and interact with services.

Header files for development with %{name}.

#------------------------------------------------

%prep
%setup -q -n cpprestsdk-%{version}
%apply_patches

# Remove bundled sources of websocketpp
rm -r Release/libs
# Remove file ThirdPartyNotices.txt, which is associated to websocketpp
rm ThirdPartyNotices.txt

%build
%cmake \
	-DCMAKE_BUILD_TYPE=Release \
	-DCPPREST_EXPORT_DIR=cmake/cpprestsdk \
	-DWEBSOCKETPP_INCLUDE_DIR=%{_includedir}/websocketpp \
	-DWERROR=OFF \
	-DCPPREST_EXCLUDE_BROTLI=OFF \
	../Release

%make_build

%install
%make_install -C build

# create a pkgconfig file
install -d %{buildroot}%{_libdir}/pkgconfig
cat << EOF > %{buildroot}%{_libdir}/pkgconfig/%{name}.pc
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: %{name}
Description: cloud-based client-server communication
URL: %{url}
Version: 2.10.18
Libs: -L%{_libdir} -lcpprest
Cflags: -I%{_includedir}/cpprest -I%{_includedir}/pplx
EOF

%files -n %{libname}
%doc license.txt
%doc CONTRIBUTORS.txt
%{_libdir}/libcpprest.so.%{major}*

%files -n %{develname}
%doc license.txt
%doc CONTRIBUTORS.txt
%{_includedir}/%{name}/
%{_includedir}/pplx/
%{_libdir}/libcpprest.so
%{_libdir}/cmake/cpprestsdk/
%{_libdir}/pkgconfig/%{name}.pc


%changelog
* Mon Feb 28 2022 tex - 2.10.18-1pclos2022
- new version

* Thu Feb 27 2020 tex - 2.10.15-1pclos2020
- new version

* Sun Jun 30 2019 tex - 2.10.13-1pclos2019
- new version

* Sat Jun 01 2019 tex - 2.10.12-2pclos2019
- rebuild against updates

* Thu May 23 2019 tex - 2.10.12-1pclos2019
- new
